import engine;

import std.file;
import std.stdio;


import map;

class M : Engine{
//******************************************
this(){
	super( Video512x512, true, 50, true);

	FontEngine.instance.loadFont("a.ttf", 20);

	setTitle("OMFG FF1!!!");

	map = new Map("map.dat");
	jump(&openingText);
}
//**************************************************************

Map map;
Image i;
int px = 0;
int py = 0;


bool nothing(int timer){
	return true;
}


bool waitOnKeypress(int timer){
	if(buttonWasPressed(cross))
		return false;
	return true;
}

bool scrollUp(int timer){
	if(timer == 0){
		py--;
		if(py < 0)
			py += map.height;
	}

	if((timer * 4) >= 16)
		return false;
	
	scope Painter p = new Painter(screen);
	map.draw(p, px, py, 0, 16-(timer * 4));

		p.drawImage(XY(256, 256), i);
	return true;
}

bool scrollDown(int timer){
	if((timer * 4) >= 16){
		py++;
		if(py >= map.height)
			py -= map.height;
		return false;
	}
	
	scope Painter p = new Painter(screen);
	map.draw(p, px, py, 0, (timer * 4));

		p.drawImage(XY(256, 256), i);
	return true;
}

bool scrollLeft(int timer){
	if(timer == 0){
		px--;
		if(px < 0)
			px += map.width;
	}

	if((timer * 4) >= 16)
		return false;
	
	scope Painter p = new Painter(screen);
	map.draw(p, px, py, 16-(timer * 4), 0);

		p.drawImage(XY(256, 256), i);
	return true;
}

bool scrollRight(int timer){
	if((timer * 4) >= 16){
		px++;
		if(px < 0)
			px += map.width;
		return false;
	}
	
	scope Painter p = new Painter(screen);
	map.draw(p, px, py, (timer * 4), 0);

		p.drawImage(XY(256, 256), i);
	return true;
}

bool overWorld(int timer){
	if(timer == 0){
		i = new Image(512, 512);
		scope Painter p = new Painter(i);
		map.draw(p, px, py);
//		p.blend(RGBA(0,0,255,127));
//		p.blend(RGBA(0,10,110,190));
		call(&transitionIn);
	}else
	if(timer == 2){	// timer == 1 is the placeholder for the transitionIn call
		audio.playMusic("o.mid");
		i = new Image("char.png");
	}else{
		scope Painter p = new Painter(screen);
//		map.draw(p, px, py);
		map.draw(p, px, py);
		p.drawImage(XY(256, 256), i);
//		p.blend(RGBA(0,0,255,127));
	//	p.blend(RGBA(0,10,110,190));
	}

	if(directionIsDown(up))
		call(&scrollUp);
	if(directionIsDown(down))
		call(&scrollDown);
	if(directionIsDown(left))
		call(&scrollLeft);
	if(directionIsDown(right))
		call(&scrollRight);

	if(buttonWasPressed(circle)){
		scope Painter p = new Painter(screen);
		const int width = 512-32 -8;
		const int height = 512-32 -8;
		Point w = drawShadedRect(p, XY(32-16,32-16), width, height);
		p.box(w, XY(w.x + width, w.y + height), RGBA(0,0,255, 160));
		p.drawText(w, "CONTINUE");
		call(&waitOnKeypress);
	}
	return true;
}

bool transitionIn(int timer){
	int a = timer * 10;

	scope Painter p = new Painter(screen);

	p.drawImage(XY(0,0), i);

	p.box(XY(0,0), XY(512, 256 - a), RGB(0,0,0));
	p.box(XY(0, 256 + a), XY(512, 512), RGB(0,0,0));

	if(a > 240)
		return false;

	return true;

}

bool transitionOut(int timer){
	int a = 240 - timer * 10;

	scope Painter p = new Painter(screen);
	p.box(XY(0,0), XY(512, 256 - a), RGB(0,0,0));
	p.box(XY(0, 240 + a), XY(512, 256), RGB(0,0,0));

	if(a < 0)
		return false;

	return true;
}

bool startingMenu(int timer){
	if(timer == 0){
		scope Painter p = new Painter(screen);
		p.fill(RGB(0,0,0));
		audio.playMusic("p.mid");
		const int width = 100;
		const int height = 30;
		Point w = drawShadedRect(p, XY(100,100), width, height);
		p.box(w, XY(w.x + width, w.y + height), RGB(0,0,255));
		p.drawText(w, "CONTINUE", RGB(255,255,255), RGB(0,0,255));
	}

	if(buttonWasPressed(circle))
		jump(&overWorld);
	return true;
}

bool openingText(int time){
	scope Painter p = new Painter(screen);
	if(time == 0){
		p.fill(RGB(0,0,255));
		audio.playMusic("p.mid");
	}
	if(time == 1)	// hack
		p.fill(RGB(0,0,255));

	if(buttonWasPressed(circle) || buttonIsDown(start))
		jump(&startingMenu);

	static int a;

	static char[][] t = [
		"The world is veiled in",
		"darkness. The wind stops,",
		"the sea is wild,",
		"and the earth begins to rot.",
		"The people wait,",
		"their only hope, a prophecy....",
		"'When the world is in darkness",
		"Four Warriors will come....'",
		"After a long journey, four",
		"young warriors arrive",
		"each holding an ORB."
	];

	if(a == t.length)
		return true;
	if(time && time % 20 == 0)
		a++;
	if(a == t.length)
		return true;

	p.drawTextCenteredHoriz(a * 35 + 30, t[a], RGB(time % 20 * 10 + 55,time % 20 * 10 + 55 ,time % 20 * 10 + 55), RGB(0,0,255));

	return true;
}

}
//*************************************

void main(){
	Engine engine = new M;
	engine.run;
	delete engine;
}

/**
	width and height are the width and height of the area INSIDE the border
	There is a 4x4 offset in the corners to the client area
*/

const int lineWidth = 1;

Point drawShadedRect(Painter p, Point where, int width, int height){
	int x = where.x;
	int y = where.y;

	Color gray = RGB(128,128,128);

	p.box(XY(x + 2, y), XY( x + 2 + width + 2, y + 4), gray);
	p.box(XY(x + 2, y + height + 4), XY( x + 2 + width + 2, y + 4 + height + 4 ), gray);

	p.box(XY(x, y + 2), XY(x + 4, y + 2 + height + 2), gray);
	p.box(XY(x + 4 + width, y + 2), XY(x + 4 + width + 4, y + 2 + height + 2), gray);

	p.putpixel(XY(x + 1, y + 1), gray);
	p.putpixel(XY(x + 1, y + 4 + 3 + height), gray);
	p.putpixel(XY(x + 4 + width + 3, y + 1), gray);
	p.putpixel(XY(x + 4 + width + 3, y + 4 + 3 + height), gray);


	Color white = RGB(255,255,255);

	p.hline(XY(x + 4, y + 1),              width + 2, white);
	p.hline(XY(x + 4, y + 4 + height + 1), width + 2, white);

	p.vline(XY(x + 1, y + 3),             height + 2, white);
	p.vline(XY(x + 4 + width + 3, y + 3), height + 2, white);

	return XY(x + 4, y + 4);
}


