version(Engine) import engine;

import std.outbuffer;

/*
	Tile file format
*/

struct Tile{
	version(Engine){
		Image[] frames;
		int counterNeeded;	/// the random amount needed for this frame
		int counter;		/// current time counter
		int currentFrame;
	}

	version(Editor){
		char[][] frameImageNames;
	}

// Persistent --
	ubyte numFrames;
	int[] frameWaitMin;	/// the counterNeeded = random between this and the next
	int[] frameWaitMax;

	ubyte canDrive;	/// one bit for each class of vehicle
	ubyte canPark;

	ubyte flags;
	const ubyte CAN_WALK = 0x1;
	const ubyte OVERDRAW = 0x2;		/// Is the tile drawn on top of the character?
	const ubyte ANIMATED = 0x4;		/// is the tile animated by default?
	const ubyte ANIMATED_AFTER_STEP = 0x8;	/// does the animation reset and play once after you step on it?

	int damage;		/// How much damage does stepping on the tile do to your party?
	ubyte battleFrequency;	/// Random battle counter decrement value

	char[] battleBackgroundName;

//*****************************************

	version(Editor){
	/**
		Creates an array of bytes suitable to be directly written
		to a work-in-progress file.
	*/
	ubyte[] serializeWIP(){
		OutBuffer outb = new OutBuffer;
		outb.reserve(numFrames * 1024 + 512);	// guesstimate for speed optimization

		outb.write(numFrames);
		for(int a = 0; a < numFrames; a++){
			ubyte l = frameImageNames[a].length;
			outb.write(l);
			outb.write(frameImageNames[a]);
			outb.write(frameWaitMin[a]);
			outb.write(frameWaitMax[a]);
		}

		outb.write(canDrive);
		outb.write(canPark);
		outb.write(flags);
		outb.write(damage);
		outb.write(battleFrequency);
		ubyte l = battleBackgroundName.length;
		outb.write(l);
		outb.write(battleBackgroundName);

		return outb.toBytes();
	}

	}
	/**
		The opposite of serializeWIP.
	*/
	void loadWIP(ubyte[] data){

	}
}
