import std.stdio;
import std.string;
import std.file;

import tile;
import vehicle;

/* A few simpler calls than what the standard library provides (that I know about, that is) */
char[] readline(){
	char line[80];
	if(scanf("%80[^\n]%*c", line.ptr) != 1)
		throw new Exception("Readline failure");
	char[] s = toString(toStringz(line));
	return s;
}

int readint(){
	int a;
	if(scanf("%i%*c", &a) != 1)
		throw new Exception("Readint failure");
	return a;
}

bool readbool(){
	char[] a = readline();
	if(a == "yes" || a == "y" || a == "YES" || a == "Y" || a == "TRUE"
	 ||a == "1"   || a == "true" || a == "T" || a == "t")
		return true;
	return false;
}

int main(char[][] args){
	Tile t;

	writefln("Enter the filenames and wait times for each frame in the tile's animation.\n"
		 "When you are done, type DONE in all caps.");

	int a;

	char[] line;

	do{
		writef("      Image Filename: ");
		line = readline();
		if(line == "DONE")
			break;
		writef("Minimum display time: ");
		int min = readint();

		writef("Maximum display time: ");
		int max = readint();


		if(a == t.frameImageNames.length){
			t.frameImageNames.length = t.frameImageNames.length + 3;
			t.frameWaitMin.length = t.frameWaitMin.length + 3;
			t.frameWaitMax.length = t.frameWaitMax.length + 3;
		}

		t.frameImageNames[a] = line;
		t.frameWaitMin[a]    = min;
		t.frameWaitMax[a]    = max;

		a++;
	} while(line != "DONE");

	t.numFrames = a;



	ubyte flags = 0;
	bool answer;
	a = 0;

	writef("Can the character walk on this tile? ");
	answer = readbool();
	if(answer) flags |= (1<<a); a++;

	writef("What is the filename of the image that will be displayed as a battle background?\n"
	       "Type NONE in all caps if you do not care. ");
	line = readline();
	t.battleBackgroundName = line;

	writef("How much damage will stepping on this tile do to the party? ");
	int d = readint();
	t.damage = d;

	writef("How much should the random battle counter be decreased with each step on\n"
	       "this tile? (Reasonable numbers are between 0 and 10, with 0 being none and\n"
	       "10 being more battles). ");
	int x = readint();
	t.battleFrequency = x;

	writef("Is this tile drawn over the character? (If you say yes, this creates\n"
	       "an effect similar to walking on forests in Final Fantasy. ");
	answer = readbool();
	if(answer) flags |= (1<<a); a++;

	if(t.numFrames > 1){
		writef("Is the tile normally animated when doing nothing? ");
		answer = readbool();
		if(answer) flags |= (1<<a); a++;

		writef("Does the tile's animation reset and play once after you step on it?  ");
		answer = readbool();
		if(answer) flags |= (1<<a); a++;
	}

	for(a = 0; a < 8; a++){
		writef("Can %s class vehicles drive on this tile? ", vehicle.classNames[a]);
		answer = readbool();
		if(answer) t.canDrive |= (1<<a);

		writef("Can %s class vehicles park on this tile? ", vehicle.classNames[a]);
		answer = readbool();
		if(answer) t.canPark |= (1<<a);
	}



	writef("And lastly, what filename do you want to save this file under?\n"
	       "Type ABORT in all caps if you do not want to save. ");
	char[] file = readline();
	if(file == "ABORT")
		return 0;

	ubyte[] data = t.serializeWIP();
	write(file, data);

	return 0;
}
